#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>

#include "query.h"

//#define DEBUG_QUERY


query_buf_t* query_buf_find_last (histories_t *histories)
{
	query_buf_t *out;	
	
	if ((out = histories->query_bufs) != NULL) {
		while (out->next) {
			out = out->next;			
		}		
	}	
	
	return out;
}


query_buf_t* query_buf_find_id (histories_t *histories, int bufid)
{
	query_buf_t *out;

	if ((out = histories->query_bufs) != NULL) {
		do {
			if (out->bufid == bufid) {
				return out;
			}
		} while ((out = out->next) != NULL);
	}		
	
	//printf ("can't found query_buf with bufid = %d\n", bufid);
	return NULL;	
}


int query_buf_add_first (histories_t *histories, query_buf_t *query_buf)
{
	if (histories->query_bufs) {
		query_buf->next = histories->query_bufs;
		query_buf->next->prev = query_buf;
		query_buf->prev = NULL;
		histories->query_bufs = query_buf;
	} else {
		query_buf->next = NULL;
		query_buf->prev = NULL;
		histories->query_bufs = query_buf;
	}	
	
	return 0;
}


int query_buf_add_after (histories_t *histories, query_buf_t *prev, query_buf_t *query_buf)
{
	if (prev->next) {
		query_buf->next = prev->next;
	} else {
		query_buf->next = NULL;		
	}
	query_buf->prev = prev;
	prev->next = query_buf;

	return 0;	
}


int query_buf_remove_id (histories_t *histories, int bufid)
{
	query_buf_t *query_buf;
	
	query_buf = query_buf_find_id (histories, bufid);
	if (query_buf == NULL) {
		return (-1);		
	}
	
	if (query_buf->values) {
		free (query_buf->values);
		query_buf->values = NULL;
	}
	if (query_buf->name) {
		free (query_buf->name);
		query_buf->name = NULL;
	}	
	
	if (query_buf->prev) {
		query_buf->prev->next = query_buf->next;
	} else {
		histories->query_bufs = query_buf->next;
	}
	if (query_buf->next) {
		query_buf->next->prev = query_buf->prev;
	}		
	
	memset (query_buf, 0, sizeof (query_buf));
	free (query_buf);
	query_buf = NULL;
	
	return 0;
}


